#
# Tcl/Tk script to iterate all the files for a given directory.
# eryar@163.com
# 2015-01-18
#

package require Tcl
package require Tk

wm title . "Iterate Files"

label .labelDirectory -text "Directory "
entry .entryDirectory -width 30 -relief sunken -textvariable aDirectory
button .buttonDirectory -text "..." -command {chooseDirectory .entryDirectory}

button .buttonApply -text "Apply" -command {perform $aDirectory}
button .buttonCancel -text "Cancel" -command {exit}

grid .labelDirectory .entryDirectory .buttonDirectory
grid .buttonApply .buttonCancel

# chooseDirectory--
# choose the directory to iterate.
# 
proc chooseDirectory {theEntry} {
    set dir [tk_chooseDirectory -initialdir [pwd] -mustexist 1]
    
    if {[string compare $dir ""]} {
        $theEntry delete 0 end
        $theEntry insert 0 $dir
        $theEntry xview end
    }
}

# perform--
# perform the algorithm.
#
proc perform {theDirectory} {
    puts "Iterate all the files in $theDirectory"
    
    if {[string length $theDirectory] < 1} {
        tk_messageBox -type ok -icon warning -message "Please select the directory!" -parent .
        return 
    }
    
    # process the iterate...
    process $theDirectory
}

# process--
# recursion every folder and file.
#
proc process {theFolder} {

    set aFiles [glob -nocomplain -directory $theFolder *]
    
    foreach aFile $aFiles {
        if {[file isfile $aFile]} {
            # just output the file name here. 
            # you can do something such as rename for the file.
            puts "$aFile \n"
        } else {
            process $aFile
        }
    }
}